/* FROM KERNEL/SYS.C WHICH IS MOSTLY EMPTY */
/* only setgid, time, setuid, stime, times, brk, 
   setpgid, setpgrp, setsid, uname, umask implemented here */
/* NR 0..66 partially done ... lots of dummies ... see fs.* and stuff ... */

int sys_brk(unsigned long end_data_seg)
{
        if (end_data_seg >= current->end_code &&
            end_data_seg < current->start_stack - 16384)
                current->brk = end_data_seg;
        return current->brk;
}

/* THIS IS INCLUDE LINUX KERNEL.H NEXT: */
/*
 * 'kernel.h' contains some often-used function prototypes etc
 */
void verify_area(void * addr,int count);
volatile void panic(const char * str);
int printf(const char * fmt, ...);
int printk(const char * fmt, ...);
int tty_write(unsigned ch,char * buf,int count);
/* THIS IS INCLUDE LINUX MM.H NEXT: */
#ifndef _MM_H
#define _MM_H

#define PAGE_SIZE 4096

extern unsigned long get_free_page(void);
extern unsigned long put_page(unsigned long page,unsigned long address);
extern void free_page(unsigned long addr);

#endif
/* THIS IS KERNEL PANIC.C NEXT: */
/*
 * This function is used through-out the kernel (includeinh mm and fs)
 * to indicate a major problem.
 */
#include <linux/kernel.h>

volatile void panic(const char * s)
{
	printk("Kernel panic: %s\n\r",s);
	for(;;);
}
/* THIS IS INCLUDE ASM MEMORY.H NEXT: */
/*
 *  NOTE!!! memcpy(dest,src,n) assumes ds=es=normal data segment. This
 *  goes for all kernel functions (ds=es=kernel space, fs=local data,
 *  gs=null), as well as for all well-behaving user programs (ds=es=
 *  user data space). This is NOT a bug, as any user program that changes
 *  es deserves to die if it isn't careful.
 */
#define memcpy(dest,src,n) ({ \
void * _res = dest; \
__asm__ ("cld;rep;movsb" \
	::"D" ((long)(_res)),"S" ((long)(src)),"c" ((long) (n)) \
	:"di","si","cx"); \
_res; \
})
